export class Item {
  name
  sell_in
  quality

  constructor(name, sell_in, quality) {
    this.name = name
    this.sell_in = sell_in
    this.quality = quality
  }

  isAgedBrie() {
    return 'Aged Brie'
  }

  isSulfuras() {
    return 'Sulfuras, Hand of Ragnaros'
  }

  isBackStagePass() {
    return 'Backstage passes to a TAFKAL80ETC concert'
  }

  toString() {
    return `${this.name}, ${this.sell_in}, ${this.quality}`
  }

  createBackStagePass(sell_in, quality) {
    new BackStagePass(
      'Backstage passes to a TAFKAL80ETC concert',
      sell_in,
      quality
    )
  }

  createSulfuras(sell_in, quality) {
    new Sulfuras(sell_in, quality)
  }

  createNormalItem(name, sell_in, quality) {
    new Item(name, sell_in, quality)
  }

  createAgedBrie(sell_in, quality) {
    new AgedBrie(sell_in, quality)
  }

  _updateItem(item) {
    this.updateQuality(item)
    this.updateSellIn(item)
    this.updateQualityAfterExpired(item)
  }

  updateQuality(item) {
    if (item.quality > 0) {
      item.quality = item.quality - 1
    }
  }

  updateSellIn(item) {
    if (item.name === this.isSulfuras()) {
      return
    }
    this.decreaseSellInOneDay(item)
  }

  updateQualityAfterExpired(item) {
    if (item.sell_in >= 0) {
      return
    }
    if (item.sell_in < 0) {
      if (item.name !== this.isAgedBrie()) {
        if (item.quality > 0) {
          if (item.name !== this.isSulfuras()) {
            item.quality = item.quality - 1
          }
        } else {
          item.quality = item.quality - item.quality
        }
      }
    }
  }

  decreaseSellInOneDay(item) {
    item.sell_in = item.sell_in - 1
  }
}
